:root {
    --b600: rgb(15, 94, 67);
    --b500: rgb(27, 119, 105);
    --b400: rgb(19, 19, 18);
    --b300: rgb(33, 35, 36);
    --b200: rgb(42, 237, 48);
    --b100: rgb(172, 192, 193);
    --b100-93: rgba(25, 26, 28, 0.93);
    --w200: rgb(255, 246, 246);
    --w400-0: rgba(53, 124, 237, 0);
}

* {
    -webkit-box-sizing: border-box;
    box-sizing: border-box;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    margin: 0;
    padding: 0;
    color: #ffffff;
    min-width: 1px;
}

body {
    background: var(--w200);
    font-family: "Source Sans Pro", Arial, Helvetica, sans-serif;

    /* padding: $padding; */
    margin: 0;

    /* display: flex; */
    -webkit-box-orient: horizontal;
    -webkit-box-direction: normal;
    -ms-flex-direction: row;
    flex-direction: row;
    -ms-flex-wrap: nowrap;
    flex-wrap: nowrap;
    min-height: 100vh;
    overflow-x: hidden;
    overflow-y: hidden;
}

/* Left Component */
#left {
    position: fixed;
    width: 100%;
    left: 0;
    -ms-flex-negative: 0;
    flex-shrink: 0;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    z-index: 2;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    min-height: 100vh;
    -webkit-box-pack: justify;
    -ms-flex-pack: justify;
    justify-content: space-between;
    background: radial-gradient(var(--b100), var(--b500) 200%);
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
    padding: 20px;
    -webkit-transition: width 0.5s ease-in-out, left 0.5s ease-in-out;
    transition: width 0.5s ease-in-out, left 0.5s ease-in-out;
}

header {
    width: 100%;
    height: 100px;
    -ms-flex-negative: 0;
    flex-shrink: 0;
}

header h1 {
    color: #ffffff;
    font-size: 1.1em;
    text-align: center;
}

aside {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-align: end;
    -ms-flex-align: end;
    align-items: flex-end;
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
    width: 50%;
}

aside img {
    cursor: pointer;
}

aside p {
    font-weight: 400;
    color: var(--b500);
    font-size: 0.8em;
}

footer {
    width: 100%;
    -ms-flex-negative: 0;
    flex-shrink: 0;
    position: relative;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-align: baseline;
    -ms-flex-align: baseline;
    align-items: baseline;
    -webkit-box-pack: justify;
    -ms-flex-pack: justify;
    justify-content: space-between;
}

footer p {
    font-size: 0.7em;
    color: var(--w200);
}

.icon {
    opacity: 0.7;
    -webkit-transition: 0.3s ease-in-out;
    transition: 0.3s ease-in-out;
}

.icon:hover {
    opacity: 1;
    cursor: pointer;
}

/* Form Component */
form {
    width: 320px;
    padding: 50px 20px 200px 20px;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;

    /* align-items: center; */
    min-height: 100vh;
    position: relative;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
    position: absolute;
    right: 0;
}

form button {
    padding: 10px 20px;
    margin-top: 30px;
    background: var(--b600);
    width: 100%;
    max-width: 320px;
    -ms-flex-negative: 0;
    flex-shrink: 0;
    height: 5em;
    color: var(--b100);
    border: none;
    border-radius: 6px;
    cursor: pointer;
    font-weight: 600;
}

fieldset {
    border: none;
}

.panel {
    display: block;
    padding-bottom: 20px;
    width: 100%;
}

.options {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-orient: horizontal;
    -webkit-box-direction: normal;
    -ms-flex-direction: row;
    flex-direction: row;
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
}

.badge-left {
    -webkit-box-flex: 2;
    -ms-flex-positive: 2;
    flex-grow: 2;
    background: var(--b500);
    color: var(--b100);
    padding: 2px 10px 5px 10px;
    border-radius: 6px 0 0 6px;
}

.badge-right {
    padding: 2px 10px 5px 10px;
    background: var(--b200);
    border-radius: 0 6px 6px 0;
}

.badge-right input {
    border: none;
    background: none;
    width: 2.5em;
    text-align: right;
    color: var(--b500);
    font-weight: 600;
}

.badge-right input:focus {
    outline: none;
}

.pad-button {
    position: relative;
    width: calc(50% - 10px);
    height: 150px;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;

    /* background: var(--b200); */
    border-radius: 6px;

    /* padding: 10px; */
    margin: 5px;
    cursor: pointer;

    /* overflow: hidden; */
    -webkit-transform-origin: center;
    -ms-transform-origin: center;
    transform-origin: center;
    -webkit-transition: 0.5s ease-in-out;
    transition: 0.5s ease-in-out;
}

.invisible {
    display: none;
}

.background-fill {
    position: relative;
    top: 0;
    left: 0;
    width: 100%;
    -webkit-box-flex: 2;
    -ms-flex-positive: 2;
    flex-grow: 2;
    border-radius: 6px 6px 0 0;
    background: var(--b200);
    padding: 10px;
    color: var(--b500);
}

.background-fill.round-corners {
    border-radius: 6px 6px 6px 6px;
}

.sub-label {
    font-size: 1em;

    /* align-self: flex-end; */
    position: relative;
    max-width: 50px;
}

.cross {
    position: absolute;
    top: 10px;
    right: 10px;
    width: 20px;
    height: 20px;
    border-radius: 50%;
    background: var(--b500);
    -webkit-transition: -webkit-transform 0.3s ease-in-out;
    transition: -webkit-transform 0.3s ease-in-out;
    transition: transform 0.3s ease-in-out;
    transition: transform 0.3s ease-in-out, -webkit-transform 0.3s ease-in-out;
    -webkit-transform: rotate(45deg);
    -ms-transform: rotate(45deg);
    transform: rotate(45deg);
}

.cross span {
    position: absolute;
    top: 50%;
    left: 50%;
    width: 10px;
    height: 2px;
    background: var(--b200);
    border-radius: 2px;
    -webkit-transform-origin: center;
    -ms-transform-origin: center;
    transform-origin: center;
    -webkit-transform: translate(-50%, -50%) rotate(45deg);
    -ms-transform: translate(-50%, -50%) rotate(45deg);
    transform: translate(-50%, -50%) rotate(45deg);
}

.cross span:nth-child(2) {
    -webkit-transform: translate(-50%, -50%) rotate(-45deg);
    -ms-transform: translate(-50%, -50%) rotate(-45deg);
    transform: translate(-50%, -50%) rotate(-45deg);
}

input:checked ~ .background-fill {
    background: var(--b500);
    color: var(--b100);
}

input:checked ~ .background-fill .cross {
    background: var(--b200);
    -webkit-transform: rotate(0);
    -ms-transform: rotate(0);
    transform: rotate(0);
}

input:checked ~ .background-fill .cross span {
    background: var(--b500);
}

.character-class-range {
    position: relative;
    width: 100%;
    bottom: 0;
    left: 0;
    background: var(--b100);
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    padding: 5px;
    border-radius: 0 0 6px 6px;
    overflow: hidden;
}

.character-class-range label {
    position: relative;
    width: 50%;
    overflow: hidden;
}

.character-class-range label span {
    display: block;
    width: 100%;
    font-size: 0.8em;
    text-align: center;
    color: var(--b500);
}

.character-class-min,
.character-class-max {
    text-align: center;
    width: 100%;
    border: none;
    background: none;
    font-size: 1.5em;
    color: var(--b400);
}

.character-class-min:focus,
.character-class-max:focus {
    outline: none;
    background: var(--b500);
    color: var(--b200);
}

legend {
    color: var(--b500);
    font-weight: 600;
    padding: 5px 10px;
}

/* Generated Password Component */
.generated-password-wrapper {
    position: fixed;
    width: 100vw;
    min-height: 100vh;

    /* background: var(--b100-93); */
    top: 0;
    left: 0;
    -ms-flex-negative: 0;
    flex-shrink: 0;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    -webkit-box-pack: end;
    -ms-flex-pack: end;
    justify-content: flex-end;
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
    padding: 60px 20px;
    display: none;
    pointer-events: none;
    z-index: 3;
}

.generated-password-self {
    position: relative;
    width: 50%;
    min-width: 250px;
    background: var(--b400);
    border-radius: 6px;
    padding: 20px;
    color: var(--w200);
    font-size: 3em;
    -webkit-box-shadow: 2px 2px 30px 4px rgba(27, 62, 119, 0.36);
    box-shadow: 2px 2px 30px 4px rgba(27, 62, 119, 0.36);
    cursor: pointer;
    pointer-events: visible;
}

.generated-password-self:after {
    content: " ";
    position: absolute;
    width: 80px;
    height: 100%;
    top: 0;
    right: 0;
    background: -webkit-gradient(linear, left top, right top, from(var(--w400-0)), color-stop(75%, var(--b400)));
    background: linear-gradient(to right, var(--w400-0), var(--b400) 75%);
    border-radius: 0 6px 6px 0;
    pointer-events: none;
}

.generated-password-inner {
    overflow: hidden;
}

#password-field {
    font-family: "Courier New", Courier, monospace;
    white-space: nowrap;
}

#password-field::-moz-selection {
    background: var(--b500);
}

#password-field::selection {
    background: var(--b500);
}

.btn-close {
    position: absolute;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
    top: -10px;
    right: -10px;
    width: 20px;
    height: 20px;
    background: var(--b500);
    z-index: 2;
    border-radius: 50%;
}

.btn-close span {
    width: 10px;
    height: 2px;
    background: var(--b100);
    border-radius: 2px;
    position: absolute;
    top: 50%;
    left: 50%;
    -webkit-transform-origin: center;
    -ms-transform-origin: center;
    transform-origin: center;
    -webkit-transform: translate(-50%, -50%) rotate(45deg);
    -ms-transform: translate(-50%, -50%) rotate(45deg);
    transform: translate(-50%, -50%) rotate(45deg);
    cursor: pointer;
}

.btn-close span:nth-child(2) {
    -webkit-transform: translate(-50%, -50%) rotate(-45deg);
    -ms-transform: translate(-50%, -50%) rotate(-45deg);
    transform: translate(-50%, -50%) rotate(-45deg);
}

.copy {
    position: absolute;
    font-size: 0.8rem;
    bottom: -0.8em;
    background: var(--b500);
    color: var(--b100);
    padding: 2px 5px 5px 5px;
    border-radius: 6px;
    opacity: 0;
    -webkit-transition: opacity 0.2s ease-in-out;
    transition: opacity 0.2s ease-in-out;
}

.copy.show {
    opacity: 1;
}

/* Shortcuts Component */
.shortcuts {
    position: relative;
    list-style: none;
    margin-top: 100px;
    width: 250px;
    padding: 30px 20px 20px 20px;
    background: var(--w200);
    border-radius: 6px;
    -webkit-box-shadow: 2px 2px 20px rgba(0, 0, 0, 0.1);
    box-shadow: 2px 2px 20px rgba(0, 0, 0, 0.1);
    display: none;
}

.shortcuts:before {
    content: "shortcuts";
    position: absolute;
    top: -0.7em;
    left: 0.8em;
    background: var(--b400);
    color: var(--w200);
    padding: 2px 10px 3px 10px;
    border-radius: 6px;
}

.shortcuts li {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-pack: justify;
    -ms-flex-pack: justify;
    justify-content: space-between;
    -webkit-box-align: baseline;
    -ms-flex-align: baseline;
    align-items: baseline;
    font-size: 0.8em;
    color: var(--b500);
}

.shortcuts li .keyboard-btn {
    position: relative;
    background: var(--b500);
    color: var(--b100);
    padding: 5px 10px 8px 10px;
    display: inline-block;
    border-radius: 6px;
    min-width: 2.5em;
    text-align: center;
}

.shortcuts li + li {
    margin-top: 10px;
}

input[type=number]::-webkit-inner-spin-button {
    -webkit-appearance: none;
}

input[type=range] {
    -webkit-appearance: none;
    margin: 18px 0 40px 0;
    width: 100%;
}

input[type=range]:focus {
    outline: none;
}

input[type=range]::-webkit-slider-runnable-track {
    width: 100%;
    height: 4px;
    cursor: pointer;
    -webkit-animation: 0.2s;
    animation: 0.2s;
    background: var(--b300);
    border-radius: 4px;
}

input[type=range]::-webkit-slider-thumb {
    border: 4px solid var(--b500);

    /* box-shadow: 0 0 0 4px var(--w200); */
    height: 16px;
    width: 16px;
    border-radius: 50%;
    background: var(--b100);
    cursor: pointer;
    -webkit-appearance: none;
    margin-top: -6px;
}

input[type=range]:focus::-webkit-slider-runnable-track {
    background: var(--b300);
}

.back-button {
    position: fixed;
    bottom: 20px;
    left: 10px;
    width: 40px;
    height: 40px;
    display: none;
    background: var(--b500);
    border: solid 2px var(--w200);
    -webkit-box-shadow: 2px 2px 12px 0 rgba(0, 0, 0, 0.1), -2px -2px 20px 0 rgba(255, 255, 255, 0.2);
    box-shadow: 2px 2px 12px 0 rgba(0, 0, 0, 0.1), -2px -2px 20px 0 rgba(255, 255, 255, 0.2);
    border-radius: 50%;
    cursor: pointer;
    z-index: 1;
}

.back-button span {
    position: absolute;
    top: 50%;
    left: 50%;
    width: 10px;
    height: 2px;
    background: var(--b200);
    border-radius: 2px;
    -webkit-transform-origin: 1px 1px;
    -ms-transform-origin: 1px 1px;
    transform-origin: 1px 1px;
    -webkit-transform: translate(-4px, -1px) rotate(-45deg);
    -ms-transform: translate(-4px, -1px) rotate(-45deg);
    transform: translate(-4px, -1px) rotate(-45deg);
}

.back-button span:nth-child(2) {
    -webkit-transform: translate(-4px, -1px) rotate(45deg);
    -ms-transform: translate(-4px, -1px) rotate(45deg);
    transform: translate(-4px, -1px) rotate(45deg);
}

.settings-open {
    overflow-y: scroll;
}

.settings-open #left {
    width: calc(100% - 320px);
}

@media (max-width: 763px) {
    form {
        width: 100%;
        -webkit-box-align: center;
        -ms-flex-align: center;
        align-items: center;
    }

    form legend {
        text-align: center;
    }

    form button {
        max-width: 100%;
    }

    .generated-password {
        width: 100%;
    }

    .settings-open {
    }

    .settings-open #left {
        width: 100%;
        left: -100%;
    }

    .settings-open .back-button {
        display: block;
    }
}

/* input[type="range"]::-moz-range-track {
    width: 100%;
    height: 4px;
    cursor: pointer;
    animation: 0.2s;
    background: var(--b300);
    border-radius: 4px;
}
input[type="range"]::-moz-range-thumb {
    border: 4px solid var(--b500);
    box-shadow: 0 0 0 4px var(--w200);
    height: 16px;
    width: 16px;
    border-radius: 50%;
    background: var(--b100);
    cursor: pointer;
    -webkit-appearance: none;
    margin-top: -6px;
}
input[type="range"]::-ms-track {
  width: 100%;
  height: 4px;
  cursor: pointer;
  animation: 0.2s;
  background: transparent;
  border-color: transparent;
  border-width: 16px 0;
  color: transparent;
}
input[type="range"]::-ms-fill-lower {
  background: #2a6495;
  border: 0.2px solid #010101;
  border-radius: 2.6px;
  box-shadow: 1px 1px 1px #000000, 0px 0px 1px #0d0d0d;
}
input[type="range"]::-ms-fill-upper {
  background: #3071a9;
  border: 0.2px solid #010101;
  border-radius: 2.6px;
  box-shadow: 1px 1px 1px #000000, 0px 0px 1px #0d0d0d;
}
input[type="range"]::-ms-thumb {
  box-shadow: 1px 1px 1px #000000, 0px 0px 1px #0d0d0d;
  border: 1px solid #000000;
  height: 36px;
  width: 16px;
  border-radius: 3px;
  background: #ffffff;
  cursor: pointer;
}
input[type="range"]:focus::-ms-fill-lower {
  background: #3071a9;
}
input[type="range"]:focus::-ms-fill-upper {
  background: #367ebd;
} */